/*******************************************************************************
 * FoxDroppedPickup_UIMesh generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDroppedPickup_UIMesh extends FoxDroppedPickup
    abstract
    native
    hidecategories(Navigation);

var bool bPendingDestroy;
var repnotify FoxPRI PickedUpPRI;
var const class<FoxBillboardUIPickupBase> BillboardClass;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        PickedUpPRI
}

simulated function PostBeginPlay()
{
    local FoxPC PC;

    super.PostBeginPlay();
    // End:0x83
    foreach LocalPlayerControllers(class'FoxPC', PC)
    {
        // End:0x82
        if(PC.myHUD != none)
        {
            PC.myHUD.AddPostRenderedActor(self);
        }        
    }    
    //return;    
}

simulated event ReplicatedEvent(name VarName)
{
    // End:0x21
    if(VarName == 'PickedUpPRI')
    {
        NotifyPickedUpByPRI();
    }
    super(DroppedPickup).ReplicatedEvent(VarName);
    //return;    
}

function PickedUpBy(Pawn P)
{
    PickedUpPRI = FoxPRI(P.PlayerReplicationInfo);
    // End:0x6C
    if(PickedUpPRI != none)
    {
        NotifyPickedUpByPRI();
        bPendingDestroy = true;
        SetTimer(7.0, false, 'DelayedDestroy');
    }
    // End:0x7F
    else
    {
        super(DroppedPickup).PickedUpBy(P);
    }
    //return;    
}

simulated function NotifyPickedUpByPRI()
{
    local PlayerController PC;
    local FoxHudUI HudUI;
    local bool bFirstPerson;

    PC = GetALocalPlayerController();
    // End:0x13E
    if(PC != none)
    {
        bFirstPerson = PC.PlayerReplicationInfo == PickedUpPRI;
        // End:0x13E
        if(FoxPC(PC).DynamicUI != none)
        {
            HudUI = FoxPC(PC).DynamicUI.HUD;
            // End:0x13E
            if((HudUI != none) && HudUI.HudPanel != none)
            {
                HudUI.HudPanel.PickupPickedUp(self, bFirstPerson);
            }
        }
    }
    //return;    
}

function DelayedDestroy()
{
    Destroy();
    //return;    
}

simulated function Destroyed()
{
    local FoxPC PC;

    // End:0x79
    foreach LocalPlayerControllers(class'FoxPC', PC)
    {
        // End:0x78
        if(PC.myHUD != none)
        {
            PC.myHUD.RemovePostRenderedActor(self);
        }        
    }    
    super(DroppedPickup).Destroyed();
    //return;    
}

auto state Pickup
{
    function bool ValidTouch(Pawn Other)
    {
        local FoxPawn P;

        P = FoxPawn(Other);
        return ((((!bPendingDestroy && P != none) && P.PlayerReplicationInfo != none) && P.IsAliveAndWell()) && !P.IsInjured()) && FoxVehicle(P) == none;
        //return ReturnValue;        
    }
    stop;    
}

defaultproperties
{
    Components(0)=none
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxDroppedPickup_UIMesh.CollisionCylinder'
    Components(1)=CollisionCylinder
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxDroppedPickup_UIMesh.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}